part of fraction;
/// A currency is any fungible financial instrument on Ethereum, including Ether and all ERC20 tokens.
///
/// The only instance of the base class `Currency` is Ether.
class Currency {
  int decimals;
  String? symbol;
  String? name;
  Currency(
      this.decimals,
      this.symbol,
      this.name,
      );

  @override
  bool operator ==(Object other) {
    if (other is Currency) {
      return decimals == other.decimals;
    }
    return false;
  }

  @override
  int get hashCode => decimals.hashCode;

  static final Currency ETHER = Currency(18, 'BNB', 'Binance');

  static final WETH = {
    ChainId.MAINNET.value: Currency(18, 'WBNB', 'Wrapped BNB'),
    ChainId.TESTNET.value: Currency(18, 'WBNB', 'Wrapped BNB'),
  };
}