part of fraction;

final ONE_HUNDRED = Fraction(BigInt.from(100));

///
/// Converts a fraction to a percent
/// [fraction] the fraction to convert
///
Percent toPercent(Fraction fraction) {
  return Percent(fraction.numerator, denominator: fraction.denominator);
}

class Percent extends Fraction {
  var isPercent = true;

  Percent(BigInt numerator, {BigInt? denominator})
      : super(numerator, denominator: denominator);

  Percent operator +(covariant Fraction other) {
    return toPercent(super.add(other));
  }

  Percent operator -(covariant Fraction other) {
    return toPercent(super.subtract(other));
  }

  Percent operator *(covariant Fraction other) {
    return toPercent(super.multiply(other));
  }

  Percent operator /(covariant Fraction other) {
    return toPercent(super.divide(other));
  }

  String toSignificant(
    int significantDigits, {
    dynamic format,
        RoundingMode? rounding,
  }) {
    return super
        .multiply(ONE_HUNDRED)
        .toSignificantNative(significantDigits, format: format, rounding: rounding);
  }

  String toFixed(
    int decimalPlaces, {
    dynamic format,
        RoundingMode? rounding,
  }) {
    return super
        .multiply(ONE_HUNDRED)
        .toFixedNative(decimalPlaces, format: format, rounding: rounding);
  }
}
