part of entities;

class Token extends Currency {
  int chainId;
  EthereumAddress address;

  Token(
    this.chainId,
    this.address,
    int decimals, {
    String? symbol,
    String? name,
  }) : super(decimals, symbol, name);

  @override
  bool operator ==(Object other) {
    if (other is Token) {
      return chainId == other.chainId && address == other.address;
    } else if (other is Currency) {
      return decimals == other.decimals &&
          symbol == other.symbol &&
          name == other.name;
    } else {
      return false;
    }
  }

  @override
  int get hashCode => chainId.hashCode ^ address.hashCode ^ symbol.hashCode ^ name.hashCode;

  bool sortsBefore(Token other) {
    invariant(chainId == other.chainId, '$chainId incorrect');
    invariant(address != other.address, '$address incorrect');
    return address.hex.compareTo(other.address.hex) < 0;
  }

  @override
  String toString() {
    return symbol ?? '';
  }

  static final WETH = {
    ChainId.MAINNET.value: Token(ChainId.MAINNET.value,
        EthereumAddress.fromHex('0xbb4CdB9CBd36B01bD1cBaEBF2De08d9173bc095c'), 18,
        symbol: 'WBNB', name: 'Wrapped BNB'),
    ChainId.TESTNET.value: Token(ChainId.TESTNET.value,
        EthereumAddress.fromHex('0xae13d989dac2f0debff460ac112a837c89baa7cd'), 18,
        symbol: 'WBNB', name: 'Wrapped BNB'),
  };
}
