import 'package:pancake_sdk/core/entities/fraction/index.dart';
import 'package:pancake_sdk/core/entities/index.dart';
import 'package:pancake_sdk/core/utils/index.dart';

class TokenAmount extends CurrencyAmount {
  Token token;
  TokenAmount(this.token, BigInt raw) : super(token, raw);

  @override
  bool operator ==(covariant TokenAmount other) {
    return currency == other.currency && raw == other.raw;
  }

  @override
  int get hashCode => token.hashCode ^ raw.hashCode;

  @override
  TokenAmount operator +(covariant TokenAmount other) {
    invariant(token == other.token, 'TOKEN');
    return TokenAmount(token, raw + other.raw);
  }

  @override
  TokenAmount operator -(covariant TokenAmount other) {
    invariant(token == other.token, 'TOKEN');
    return TokenAmount(token, raw - other.raw);
  }

  @override
  String toString() {
    return '${token.symbol}, $raw';
  }
}


