import 'package:decimal/decimal.dart';

extension BigIntExt on BigInt {
  BigInt toWeiBigInt(Decimal amount, int decimals) {
    return BigInt.parse((amount * Decimal.parse('${BigInt.from(10).pow(decimals)}')).toString());
  }

  BigInt babylonianSqrt() {
    var z = BigInt.zero;
    BigInt x;

    if (this > BigInt.from(3)) {
      z = this;
      x = this ~/ BigInt.two + BigInt.one;
      while (x < z) {
        z = x;
        x = (this ~/ x + x) ~/ BigInt.two;
      }
    } else if (this != BigInt.zero) {
      z = BigInt.one;
    }
    return z;
  }
}