import 'package:decimal/decimal.dart';
import 'package:web3dart/web3dart.dart';
import 'dart:math' show pow;

import 'decimal_ext.dart';

extension EtherAmountExt on EtherAmount {
  Decimal weiToDecimalEther(int decimals) {
    var parsed = DecimalExt.fromBigInt(getInWei);
    if (parsed != null) {
      return (parsed / Decimal.fromInt(pow(10, decimals).toInt())).toDecimal();
    } else {
      return Decimal.zero;
    }
  }
}