import 'dart:math' as math;
import 'package:pancake_sdk/core/utils/index.dart';
import 'package:test/test.dart';
import 'package:pancake_sdk/core/constants.dart';

void main(){
  group('#sqrt', () {
    test('correct for 0-1000', (){
      for (int i = 0; i < 1000; i++) {
        expect(
            sqrt(BigInt.from(i)), BigInt.from(math.sqrt(i).round())
        );
      }
    });

    test('correct for all even powers of 2', (){
      for (int i = 0; i < 256; i++) {
        final root = BigInt.from(2).pow(i);
        final rootSquared = root *  root;
        expect(sqrt(rootSquared), root);
      }
    });

    test('correct for maxUint256', () => {
      expect(sqrt(MaxUint256), isNot(BigInt.parse('340282366920938463463374607431768211455')))
    });
  });

}