import 'package:flutter_test/flutter_test.dart';
import 'package:pancake_sdk/core/entities/index.dart';
import 'package:pancake_sdk/core/entities/token/tokenAmount.dart';
import 'package:web3dart/credentials.dart';

void main() {
  final addressOne = EthereumAddress.fromHex('0x0000000000000000000000000000000000000001');

  group('TokenAmount', () {
    test('add amount token', () async{
      final tokenA = Token(1, addressOne, 18);
      final tokenAmountA = TokenAmount(tokenA, BigInt.one);
      final tokenAmountB = TokenAmount(tokenA, BigInt.zero);
      expect(tokenAmountA + tokenAmountB, TokenAmount(tokenA, BigInt.one));
    });

    test('add not equal amount', () async{
      final tokenA = Token(1, addressOne, 18);
      final tokenB = Token(2, addressOne, 18);
      final tokenAmountA = TokenAmount(tokenA, BigInt.one);
      final tokenAmountB = TokenAmount(tokenB, BigInt.zero);
      expect(()=> tokenAmountA + tokenAmountB,throwsA(isA<AssertionError>()));
    });

    test('add amount token', () async{
      final tokenA = Token(1, addressOne, 18);
      final tokenAmountA = TokenAmount(tokenA, BigInt.one);
      final tokenAmountB = TokenAmount(tokenA, BigInt.zero);
      expect(tokenAmountA - tokenAmountB, TokenAmount(tokenA, BigInt.one));
    });

  });
}