import 'package:pancake_sdk/core/utils/index.dart';
import 'package:test/test.dart';
import 'package:web3dart/credentials.dart';

void main() {
  group('#validateAndParseAddress', () {
    test('returns same address if already checksummed', () {
      expect(
          validateAndParseAddress('0x5C69bEe701ef814a2B6a3EDD4B1652CB9cc5aA6f')
              .hex,
          EthereumAddress.fromHex('0x5C69bEe701ef814a2B6a3EDD4B1652CB9cc5aA6f')
              .hex);
    });

    test('returns checksummed address if not checksummed', () {
      expect(
          validateAndParseAddress(
                  '0x5C69bEe701ef814a2B6a3EDD4B1652CB9cc5aA6f'.toLowerCase())
              .hex,
          EthereumAddress.fromHex('0x5C69bEe701ef814a2B6a3EDD4B1652CB9cc5aA6f')
              .hex);
    });
  });
}
